VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmPalette 
   BorderStyle     =   1  'Fixed Single
   Caption         =   " Palette"
   ClientHeight    =   5925
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4185
   Icon            =   "Palette.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   5925
   ScaleWidth      =   4185
   WindowState     =   1  'Minimized
   Begin VB.Frame zFrame1 
      Caption         =   "Informazioni"
      Height          =   1455
      Left            =   120
      TabIndex        =   1
      Top             =   4200
      Width           =   3945
      Begin VB.Label zLabel08 
         BackStyle       =   0  'Transparent
         Caption         =   "Blue:"
         Height          =   255
         Left            =   3240
         TabIndex        =   15
         Top             =   840
         Width           =   495
      End
      Begin VB.Label zLabel07 
         BackStyle       =   0  'Transparent
         Caption         =   "Green;"
         Height          =   255
         Left            =   2400
         TabIndex        =   14
         Top             =   840
         Width           =   495
      End
      Begin VB.Label zLabel06 
         BackStyle       =   0  'Transparent
         Caption         =   "Red:"
         Height          =   255
         Left            =   1560
         TabIndex        =   13
         Top             =   840
         Width           =   495
      End
      Begin VB.Label lblBlue 
         BorderStyle     =   1  'Fixed Single
         Height          =   255
         Left            =   3240
         TabIndex        =   12
         Top             =   1080
         Width           =   495
      End
      Begin VB.Label lblGreen 
         BorderStyle     =   1  'Fixed Single
         Height          =   255
         Left            =   2400
         TabIndex        =   11
         Top             =   1080
         Width           =   495
      End
      Begin VB.Label lblRed 
         BorderStyle     =   1  'Fixed Single
         Height          =   255
         Left            =   1560
         TabIndex        =   10
         Top             =   1080
         Width           =   495
      End
      Begin VB.Label lblColoreIndicato 
         BackStyle       =   0  'Transparent
         Caption         =   "Colore indicato:"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   1110
         Width           =   1455
      End
      Begin VB.Label zLabel04 
         Alignment       =   2  'Center
         BackStyle       =   0  'Transparent
         Caption         =   "[pixel]"
         Height          =   255
         Left            =   960
         TabIndex        =   8
         Top             =   480
         Width           =   615
      End
      Begin VB.Label zLabel03 
         BackStyle       =   0  'Transparent
         Caption         =   "Bits x Pixel:"
         Height          =   255
         Left            =   2880
         TabIndex        =   7
         Top             =   240
         Width           =   975
      End
      Begin VB.Label zLabel02 
         BackStyle       =   0  'Transparent
         Caption         =   "Altezza:"
         Height          =   255
         Left            =   1560
         TabIndex        =   6
         Top             =   240
         Width           =   735
      End
      Begin VB.Label zLabel01 
         BackStyle       =   0  'Transparent
         Caption         =   "Larghezza:"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   240
         Width           =   975
      End
      Begin VB.Label lblBxP 
         BorderStyle     =   1  'Fixed Single
         Height          =   255
         Left            =   2880
         TabIndex        =   4
         Top             =   480
         Width           =   855
      End
      Begin VB.Label lblHeight 
         BorderStyle     =   1  'Fixed Single
         Height          =   255
         Left            =   1560
         TabIndex        =   3
         Top             =   480
         Width           =   855
      End
      Begin VB.Label lblWidth 
         BorderStyle     =   1  'Fixed Single
         Height          =   255
         Left            =   120
         TabIndex        =   2
         Top             =   480
         Width           =   855
      End
   End
   Begin MSFlexGridLib.MSFlexGrid grdPalette 
      Height          =   3945
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3945
      _ExtentX        =   6959
      _ExtentY        =   6959
      _Version        =   393216
      Rows            =   16
      Cols            =   16
      FixedRows       =   0
      FixedCols       =   0
      BackColor       =   0
      AllowBigSelection=   0   'False
      Enabled         =   -1  'True
      FocusRect       =   2
      HighLight       =   0
      FillStyle       =   1
      GridLines       =   3
      ScrollBars      =   0
      MouseIcon       =   "Palette.frx":030A
   End
End
Attribute VB_Name = "frmPalette"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'==============================================================
' Descrizione.....: Mostra una tavola di colori [RGB] gia'
'                   esistente o la "Palette" e le informazioni
'                   dell' Image di un PictureBox. In questo
'                   ultimo caso, la "Palette" viene costruita
'                   con il numero di colori specificato tramite
'                   il parametro BxP [BitsPerPixels].
' Nome dei Files..: Palette.frm, Palette.frx
'                   StruttureBMP.bas
' Data............: 7/6/2000
' Versione........: 1.0 a 32 bits
' Sistema.........: Visual Basic 6.0
'                   sotto Windows NT 4.0 (SP 3).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
'==============================================================
'
'   Uso:
'    frmPalette.ApriCT ColTav()
'     ColTav():     Vettore (base 0) contenente, in formato RGB, i
'                   colori da rappresentare. Il numero di colori in
'                   ColTav() puo' essere solo 2, 16 o 256.
'     Titolo$:      Caption di questo Form [opzionale].
'
'    frmPalette.ApriPB Src as PictureBox, BxP&, [BackTras As Boolean], [Index]
'     Src:          PictureBox da esaminare.
'     BxP:          N. di [BitsPerPixel] della "Palette".
'     BackTras:     Blocca l' immagine di Src come BackGround BitMap
'                   [opzionale, default = False].
'     Index:        Indice del PictureBox [opzionale]
'
'   Nota:   Questo Form puo' essere aperto in molteplici copie per
'           poter confrontare fra di loro "palettes" o tavole di
'           colori.  In questo caso far riferimento al numero [n]
'           che appare subito a sinistra del titolo.
'
Option Explicit
'
Dim CT&()   ' Vettore dei colori da rappresentare [RGB].
Dim NCol&   ' N. di colori da rappresentare.
Dim bi As BITMAPINFO_Type
'
' Temporary files API:
Private Const MAX_PATH& = 260
Private Declare Function GetTempPath Lib "kernel32" _
Alias "GetTempPathA" (ByVal nBufferLength As Long _
, ByVal lpBuffer As String) As Long
Private Declare Function GetTempFileName Lib "kernel32" _
Alias "GetTempFileNameA" (ByVal lpszPath As String _
, ByVal lpPrefixString As String, ByVal wUnique As Long _
, ByVal lpTempFileName As String) As Long
Private Sub Form_Load()
'
'
    Dim I&
    Const CellD& = 240  ' [Twips].
'
    With grdPalette
        .Width = 16 * CellD + 105   ' [Twips].
        .Height = 16 * CellD + 105  ' [Twips].
        For I = 0 To 15
            .ColWidth(I) = CellD
            .RowHeight(I) = CellD
        Next I
    End With
'
'
'
End Sub



Public Sub ApriPB(ByVal Src As PictureBox, ByVal BxP& _
    , Optional ByVal BackTras As Boolean = False _
    , Optional ByVal Index& = -1 _
    , Optional ByVal NuovoF As Boolean = True _
    , Optional ByVal NII& = 0)
'
    Dim FP As Form
    Static NI&
'
    If IsLoaded(frmPalette) And NuovoF Then
        NI = NI + 1
        Set FP = New frmPalette
        FP.ApriPB Src, BxP, BackTras, Index, False, NI
        Exit Sub
    End If
'
    Me.Show
    Me.WindowState = vbNormal
    Me.Caption = "[" & NII & "] " & "Palette di " & Src.Name
    If Index >= 0 Then Me.Caption = Me.Caption & "(" & Index & ")"
    Me.ZOrder vbBringToFront
    Me.Refresh
'
    Legge_PictureBox Src, BxP, BackTras
    AggiornaPalette
'
    lblWidth = bi.bmiHeader.biWidth
    lblHeight = bi.bmiHeader.biHeight
    lblBxP = BxP
'
'
'
End Sub
Private Function IsLoaded(ByVal F_Form As Form) As Boolean
'
'   Ritorna True se il Form F_Form e' gia' caricato in memoria:
'
    Dim X&
'
    For X = 0 To Forms.Count - 1
        If Forms(X) Is F_Form Then
            IsLoaded = True
            Exit Function
        End If
    Next X
'
    IsLoaded = False
'
'
'
End Function

Public Sub ApriCT(ColTav&() _
    , Optional ByVal Titolo$ = "Tavola dei colori" _
    , Optional ByVal NuovoF As Boolean = True _
    , Optional ByVal NII& = 0)
'
'
    Dim BxP&, FP As Form
    Static NI&
'
    If IsLoaded(frmPalette) And NuovoF Then
        NI = NI + 1
        Set FP = New frmPalette
        FP.ApriCT ColTav(), Titolo$, False, NI
        Exit Sub
    End If
'
    CT() = ColTav()
    NCol = UBound(CT) + 1
    BxP = CLng(Log(NCol) / Log(2!))
'
    Me.Show
    Me.WindowState = vbNormal
    Me.Caption = "[" & NII & "] " & Titolo$
    Me.ZOrder vbBringToFront
    Me.Refresh
'
    AggiornaPalette
'
    lblWidth = " N.A."
    lblHeight = " N.A."
    lblBxP = BxP
'
'
'
End Sub
Private Sub AggiornaPalette()
'
'   Disegna la tavola dei colori CT():
'
    Dim C&, R&, Cl&
'
    Me.MousePointer = vbHourglass
'
    lblWidth = ""
    lblHeight = ""
    lblBxP = ""
'
    lblColoreIndicato = "Colore indicato:"
    lblRed = ""
    lblGreen = ""
    lblBlue = ""
'
    Cl = 0
    With grdPalette
        .Col = 0
        .Row = 0
        .ColSel = 15
        .RowSel = 15
        .CellBackColor = vbWhite
        .Text = "x"
'
        .FocusRect = flexFocusNone
'
        For R = 0 To 15
            For C = 0 To 15
                If Cl < NCol Then
                    .Col = C
                    .Row = R
                    .CellBackColor = CT(Cl)
                    .Text = ""
                End If
                Cl = Cl + 1
            Next C
            DoEvents
        Next R
    End With
'
    Me.MousePointer = vbDefault
'
'
'
End Sub
Private Function FileExists(ByVal FileN$) As Boolean
'
'   Verifica l' esistenza del file FileN$:
'
    Dim res&
'
    On Error Resume Next
'
    res = FileLen(FileN$)
    FileExists = (Err = 0)
'
'
'
End Function

Private Function TempFile$(Optional ByVal I3C$ = "TMP" _
    , Optional ByRef TempPath As String)
'
'   Ritorna il Nome di un File temporaneo [da cancellare
'   esplicitamente dopo l' uso].
'   Con I3C$ si possono specificare fino a tre caratteri
'   iniziali per l' identificazione del file:
'
    Dim R1&, lpBuffer$
    Dim TempFileName As String
'
    R1 = GetTempPath(0, "")
    lpBuffer$ = Space(R1)
    R1 = GetTempPath(R1, lpBuffer$)
    TempPath = Left$(lpBuffer$, R1)
'
    TempFileName = Space(MAX_PATH)
    R1 = GetTempFileName(TempPath, I3C$, 0, TempFileName)
    TempFile$ = Trim$(TempFileName)
'
'
'
End Function

Private Function Legge_PictureBox(ByVal PBSrc As PictureBox _
    , ByVal BxP&, ByVal BackTras As Boolean) As Boolean
'
'
    Dim C&, R1&, lpBits&, hMem&, FileN$
    Dim hDC_PB&, hDC_Mem&, BytesNeeded&
    Dim PB_Width&, PB_Height&, Rect As RECT_Type
'
    On Error GoTo Legge_PictureBox_ERR
'
    If BackTras Then
        'PBSrc.Picture = PBSrc.Image
        FileN$ = TempFile$
        SavePicture PBSrc.Image, FileN$
        PBSrc.Picture = LoadPicture("")
        PBSrc.Picture = LoadPicture(FileN$)
        If FileExists(FileN$) Then Kill FileN$
    End If
'
    ' Create a temporary memory DC and select into it
    ' the background picture of the PBSrc Picture Box:
    hDC_PB = GetWindowDC(PBSrc.hWnd)
    hDC_Mem = CreateCompatibleDC(hDC_PB)
'
    ' Get the size of the picture bitmap:
    R1 = GetClientRect(PBSrc.hWnd, Rect)
    PB_Width = Abs(Rect.Right - Rect.Left)
    PB_Height = Abs(Rect.Bottom - Rect.Top)
'
    ' Fill the BITMAPINFOHEADER for the desired DIB:
    bi.bmiHeader.biSize = Len(bi.bmiHeader)
    bi.bmiHeader.biWidth = PB_Width
    bi.bmiHeader.biHeight = PB_Height
    bi.bmiHeader.biPlanes = 1           ' ColorPlanes
    bi.bmiHeader.biBitCount = CInt(BxP) ' BitsPerPixel * ColorPlanes
    bi.bmiHeader.biCompression = BI_RGB
'
    ' Calculate the number of bytes needed to store the image:
    BytesNeeded = ScanAlign(PB_Width * BxP / 8) * PB_Height
'
    ' Allocate a buffer to hold the bitmap bits:
    hMem = GlobalAlloc(GMEM_MOVEABLE, BytesNeeded)
'
    If hMem <> 0 Then
        lpBits = GlobalLock(hMem)
        ' Get the bits that make up the image:
        R1 = GetDIBits(hDC_Mem, PBSrc.Picture, 0, PB_Height _
        , lpBits, bi, DIB_RGB_COLORS)
    Else
        Err.Raise vbObjectError + 3
    End If
'
    ' Prepara la tavola dei colori:
    NCol = 2 ^ BxP
    ReDim CT(0 To NCol - 1)
    For C = 0 To NCol - 1
        CT(C) = RGB(bi.bmiColors(C).rgbRed _
                  , bi.bmiColors(C).rgbGreen _
                  , bi.bmiColors(C).rgbBlue)
    Next C
'
'
Legge_PictureBox_ERR:
    Legge_PictureBox = (Err = 0)
'
    R1 = DeleteDC(hDC_Mem)
'
    If hMem <> 0 Then
        R1 = GlobalUnlock(hMem)
        hMem = GlobalFree(hMem)
    End If
'
'
'
End Function
Private Function ScanAlign(ByVal pwidth As Long) As Long
'
'   Ritorna un multiplo di 4 uguale o immediatamente
'   superiore a pwidth&:
'
    ScanAlign = (pwidth + 3) And &HFFFFFFFC
'
'
'
End Function


Private Sub Form_Unload(Cancel As Integer)
'
'
    Dim MeForm As Form
'
    Me.WindowState = vbMinimized
    DoEvents
'
    Set MeForm = Me
    Set MeForm = Nothing
'
'
'
End Sub

Private Sub grdPalette_Click()
'
'
    Dim C&, R&, Cl&
'
    C = grdPalette.MouseCol
    R = grdPalette.MouseRow
    Cl = C + 16 * R
'
    If Cl < NCol Then
        grdPalette.FocusRect = flexFocusHeavy
        lblColoreIndicato = "Colore indicato " & Cl & ":"
        lblRed = CT(Cl) And &HFF
        lblGreen = (CT(Cl) \ &H100) And &HFF
        lblBlue = (CT(Cl) \ &H10000) And &HFF
    Else
        grdPalette.FocusRect = flexFocusNone
        lblColoreIndicato = "Colore indicato:"
        lblRed = ""
        lblGreen = ""
        lblBlue = ""
    End If
'
'
'
End Sub


Private Sub grdPalette_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'
'
    Dim C&, R&, Cl&
'
    With grdPalette
        C = .MouseCol
        R = .MouseRow
        Cl = C + 16 * R
'
        If Cl < NCol Then
            '.Col = C
            '.Row = R
            .ToolTipText = "Ci: " & Str$(Cl) '& ";  RGB: " & Str$(.CellBackColor)
            .MousePointer = flexCustom
        Else
            .ToolTipText = ""
            .MousePointer = flexDefault
        End If
    End With
'
'
'
End Sub


